## #+TITLE: 
## #+AUTHOR: Emilio Torres Manzanera
## #+DATE: Time-stamp: <2020-08-11 12:26 emilio on emilio-XPS-15-9570>
## #+TAGS: 
## #+PROPERTY: header-args :results output :exports both :session 

## Load library. But first, we have to unload it if it is loaded.
## Windows: paquete.dll
## Unix: paquete.so
sharedlibrary <- paste0("paquete",.Platform$dynlib.ext)
tryCatch({
    dyn.unload(file.path(".",sharedlibrary)); 
}, warning = function(w) {
    cat("Library is not loaded.\n")
}, error = function(e) {
    cat("Library is not loaded.\n")
})
dyn.load(file.path(".",sharedlibrary), local = TRUE, now = TRUE) 

## ============================================================

x <- c(1:2)
n <- 3L
ntotal <- 7L

listainicial <- vector("list", ntotal)
for(i in 1:ntotal){
    if(i <= n) {
        listainicial[[i]]  <- x
    } else {
        listainicial[[i]]  <- NA
    }
}
mpointsR <-as.matrix(expand.grid(listainicial, KEEP.OUT.ATTRS = FALSE))
dimnames(mpointsR) <- NULL
print(mpointsR)

mpointsCpp <- .Call("expand_grid_cpp",x,  n, ntotal)
head(mpointsCpp)
class(mpointsCpp[1])

if(!all.equal(mpointsR,mpointsCpp)) stop("They are not equals!")

## library(microbenchmark)
## microbenchmark(
##     cpp=.Call("expand_grid_cpp",x,  n, ntotal),
##     R=expand.grid(listainicial, KEEP.OUT.ATTRS = FALSE)
## )

